package com.hi.music.player.adapter;

import android.graphics.drawable.Drawable;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.recyclerview.widget.RecyclerView;

import com.bumptech.glide.Glide;
import com.bumptech.glide.load.DataSource;
import com.bumptech.glide.load.engine.GlideException;
import com.bumptech.glide.load.resource.bitmap.RoundedCorners;
import com.bumptech.glide.request.RequestListener;
import com.bumptech.glide.request.RequestOptions;
import com.bumptech.glide.request.target.Target;
import com.hi.music.player.MusicApplication;
import com.hi.music.player.R;
import com.hi.music.player.databinding.ItemSearchBinding;
import com.hi.music.player.databinding.ItemSearchChildBinding;
import com.hi.music.player.helper.CommonUtils;
import com.hi.music.player.javabean.response.ResponseSearch;
import com.hi.music.player.javabean.response.child.ResponseSearchChild;

public class AdapterSearchChild extends BaseAdapter<ResponseSearchChild, ItemSearchChildBinding> {
    @Override
    protected ItemSearchChildBinding getViewBinding(ViewGroup parent) {
        return ItemSearchChildBinding.inflate(LayoutInflater.from(parent.getContext()), parent, false);
    }

    @Override
    public void onBindViewHolder(@NonNull RecyclerView.ViewHolder holder, int position) {
        ResponseSearchChild responseSearchChild = data.get(position);
        VHolder<ItemSearchChildBinding> itemHolder = (VHolder<ItemSearchChildBinding>) holder;
        ItemSearchChildBinding vb = itemHolder.getVb();


        Glide.with(MusicApplication.myApplication)
                .asDrawable()
                .apply(RequestOptions.bitmapTransform(new RoundedCorners(CommonUtils.dpToPx(13))))
                .load(responseSearchChild.getSongCovert())
                .placeholder(R.mipmap.im_placeholder)
                .listener(new RequestListener<Drawable>() {
                    @Override
                    public boolean onLoadFailed(@Nullable GlideException e, @Nullable Object model, @NonNull Target<Drawable> target, boolean isFirstResource) {
                        CommonUtils.LogMsg(e.getMessage());
                        return false;
                    }

                    @Override
                    public boolean onResourceReady(@NonNull Drawable resource, @NonNull Object model, Target<Drawable> target, @NonNull DataSource dataSource, boolean isFirstResource) {
                        return false;
                    }
                })
                .into(vb.imCovert);

        vb.tvTitle.setText(responseSearchChild.getSongTitle());
        vb.tvSubtitle.setText(responseSearchChild.getSongDescribe());
       vb.getRoot().setOnClickListener(new View.OnClickListener() {
           @Override
           public void onClick(View v) {
               if (homeItemClickListener != null) {
                   homeItemClickListener.onClickSearchResult(responseSearchChild);
               }
           }
       });

    }
}
